<%@LANGUAGE="VBSCRIPT" CODEPAGE="1252"%>
<%
' 2000-2005 L.C. Enterprises
'http://LCen.com
%>
<%
Option Explicit
%>
<!--#INCLUDE FILE="inc_db.asp"-->
<!--#INCLUDE FILE="clsBayesFilter.asp"-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<%
Dim strText, dblSpamProbability

strText = Trim(Request("txtText"))

If strText <> "" Then
	Dim objBayesFilter: Set objBayesFilter = New BayesFilter

	Call OpenConn

	'Config
	With objBayesFilter
		'Properties are commented because the values shown are the default values
		'Indicates the upper bound for good tokens, for auto-learning purposes
		'.AutoTrainGoodThreshold = 0.1
		'Indicates the lower bound for bad tokens, for auto-learning purposes
		'.AutoTrainBadThreshold = 0.9
		'Auto train when classifying based on good and bad thresholds
		'.AutoTrain = False
		'Number of tokens to consider when evaluating a string
		'.SignificantTokens = 15
		'Prob to assign to an unkown outcome
		'.UnkownBadProb = 0.5
		'Minimum number of occurrences for a token to be considered
		'.MinTokenOccurrence = 5
		'Allowed charset for tokens, all other (visible) chars are separators
		'.TokenCharset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.-!$"
		'Database connection object
		.ConnectionObject = Conn
		'Max string length for the tokens (for database saving)
		'.MaxTokenLength = 255
		'Compare mode for the dictionaries
		'.CompareMode = vbTextCompare
		Call .DatabaseLoad
	End With

	If Request("TrainGood") <> "" Then
		Call objBayesFilter.TrainGood(strText)
		Response.Write("<FONT COLOR=""RED"">Text has been trained as ham</FONT><BR>")
	Else
		If Request("TrainBad") <> "" Then
			Call objBayesFilter.TrainBad(strText)
			Response.Write("<FONT COLOR=""RED"">Text has been trained as spam</FONT><BR>")
		End If
	End If

	dblSpamProbability = objBayesFilter.Evaluate(strText)
	Response.Write("<FONT COLOR=""RED"">Spam Probability: " & CInt(dblSpamProbability * 100) & "% (" & dblSpamProbability & ")</FONT><BR>")
	Response.Write("<FONT COLOR=""RED"">Good events: " & objBayesFilter.GoodCount & " / Bad events: " & objBayesFilter.BadCount & " / Token Count: " & objBayesFilter.TokenCount & "</FONT><BR>")

	'Update database
	If objBayesFilter.TokenCount > 0 Then
		Call objBayesFilter.DatabaseSave
	End If

	'Clean up
	Set objBayesFilter = Nothing
End If
%>
<FORM ACTION="BayesTest.asp" METHOD="POST">
  <P>
    <TEXTAREA NAME="txtText" COLS="80" ROWS="20"><%=strText%></TEXTAREA>
</P>
  <P>
    <INPUT TYPE="submit" NAME="TrainBad" VALUE="Train as Spam">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <INPUT TYPE="submit" NAME="TrainGood" VALUE="Train as Ham">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <INPUT TYPE="submit" NAME="Evaluate" VALUE="Classify Text">
</P>
</FORM>
<PRE>Important:
-	The program needs to be trained before it can classify text. Only words that occur at least 5 times in different texts (default setting) are considered.
	If there isn't enough information to classify a text, the default probability will be 50% (0.5).
-	When using the program with Emails, include the full headers.


Features:
-	Only considers the "X" most significant words, measured by their probability of being spam. This is to avoid spammers filling the message
	with innocent words to decrease the spam probability.
-	Only considers words that occured a "Y" minimum amount of times. This is to avoid spammers filling the message with unknown (random) words to decrease
	the spam probability.
-	Auto-learning: it learns only if all "X" significant words that occur at least "Y" times have been found. This is to avoid the auto learning feature
	from spoiling the database by learning words wrongly.

More information:
<A HREF="http://www.paulgraham.com/spam.html" TARGET="_blank">A Plan for Spam</A>

<A HREF="http://www.paulgraham.com/better.html" TARGET="_blank">Better Bayesian Filtering</A>

Ending Spam: Bayesian Content Filtering and the Art of Statistical Language Classification
<A HREF="http://www.amazon.com/exec/obidos/tg/detail/-/1593270526/102-0359289-9816932" TARGET="_blank">ISBN: 1593270526</A>

<A HREF="http://spambayes.sourceforge.net/" TARGET="_blank">SpamBayes</A>
</PRE>
</HTML>
<%
Call CloseConn()
%>